(defvar f1        "eval"          )
(defvar f2        "toString"      )
(defvar f3        "pos"      )
(defvar f1mod     "EvalMod"       )
(defvar f2mod     "ToStringMod"   )
(defvar f3mod     "PosMod"   )
(defvar f1reducer "fold"          )
(defvar f2reducer "fold2"         )
(defvar f3reducer "fold3"         )
(defvar clientmod "Client"        )
(defvar f1prefix  (concat f1 "_") ) 
(defvar f2prefix  (concat f2 "_") ) 
(defvar f3prefix  (concat f3 "_") ) 

; 1) Introduce definitions for equations ------------------------------------------------------
(haskell-refac-newDefAllEqBodiesIn f1 f1mod)
(haskell-refac-newDefAllEqBodiesIn f2 f2mod)
(haskell-refac-newDefAllEqBodiesIn f3 f3mod)

; 2) abstract pattern variables or rec calls on pattern variables -----------------------------
(haskell-refac-generaliseAllRecAppToPatternVariablesInAllLocalDefsIn f1 f1prefix f1mod) 
(haskell-refac-generaliseAllPatternVariablesInAllLocalDefsIn f1 f1prefix f1mod) 
(haskell-refac-generaliseAllRecAppToPatternVariablesInAllLocalDefsIn f2 f2prefix f2mod) 
(haskell-refac-generaliseAllPatternVariablesInAllLocalDefsIn f2 f2prefix f2mod) 
(haskell-refac-generaliseAllRecAppToPatternVariablesInAllLocalDefsIn f3 f3prefix f3mod) 
(haskell-refac-generaliseAllPatternVariablesInAllLocalDefsIn f3 f3prefix f3mod) 

; 3) lift the business functions to the top level ---------------------------------------------
(haskell-refac-liftAllLocalDefsToTopLevelIn f1 f1prefix f1mod)                
(haskell-refac-liftAllLocalDefsToTopLevelIn f2 f2prefix f2mod)                
(haskell-refac-liftAllLocalDefsToTopLevelIn f3 f3prefix f3mod)                

; 4) abstract the business functions in the functions of interest -----------------------------
(haskell-refac-generaliseAllIdentsTopLevel f1 f1prefix "f" f1mod) 
(haskell-refac-forgetTopLevelPrefixed (concat f1 "_gen")   f1mod) 

(haskell-refac-generaliseAllIdentsTopLevel f2 f2prefix "f" f2mod) 
(haskell-refac-forgetTopLevelPrefixed (concat f2 "_gen")   f2mod)

(haskell-refac-generaliseAllIdentsTopLevel f3 f3prefix "f" f3mod) 
(haskell-refac-forgetTopLevelPrefixed (concat f3 "_gen")   f3mod)

; 5) rename the functions of interest (they have become traversal iterators) ------------------
(haskell-refac-renameTopLevelIdent f1 f1mod f1reducer)
(haskell-refac-renameTopLevelIdent f2 f2mod f2reducer) 
(haskell-refac-renameTopLevelIdent f3 f3mod f3reducer) 

; 6) reconstruct the functions of interest as calls to the traversal functions ----------------
(haskell-refac-newDefIdentApp f1reducer f1 clientmod) 
(haskell-refac-newDefIdentApp f2reducer f2 clientmod) 
(haskell-refac-newDefIdentApp f3reducer f3 clientmod) 
(haskell-refac-generaliseArgIdentIn "r2" f1reducer "e1" "x" clientmod)
(haskell-refac-generaliseArgIdentIn "r1" f2reducer "e1" "x" clientmod)
(haskell-refac-generaliseArgIdentIn "r1" f3reducer "e1" "x" clientmod)
(haskell-refac-liftDefToTopLevel f1   clientmod)
(haskell-refac-liftDefToTopLevel f2   clientmod) 
(haskell-refac-liftDefToTopLevel f3   clientmod) 

; 7) make calls to function of interest appear and move fold operators-------------------------
(haskell-refac-foldToplevelDefinition f1 clientmod)
(haskell-refac-foldToplevelDefinition f2 clientmod)
(haskell-refac-foldToplevelDefinition f3 clientmod)

(haskell-refac-moveDefBetweenModules f1reducer f1mod "Expr")
(haskell-refac-moveDefBetweenModules f2reducer f2mod "Expr")
(haskell-refac-moveDefBetweenModules f3reducer f3mod "Expr")
(haskell-refac-replaceIdentIn f2reducer f2 clientmod f1reducer)
(haskell-refac-replaceIdentIn f3reducer f3 clientmod f1reducer)
(haskell-refac-removeTopLevelDef f2reducer "Expr")
(haskell-refac-removeTopLevelDef f3reducer "Expr")

; 8) move business functions to the data-centered modules and rename them ---------------------
(haskell-refac-moveAllDefsOnSuffix f3prefix f3mod)
(haskell-refac-moveAllDefsOnSuffix f2prefix f2mod)
(haskell-refac-moveAllDefsOnSuffix f1prefix f1mod)

(haskell-refac-renameAllIdentsIn f1 f1prefix clientmod)
(haskell-refac-renameAllIdentsIn f2 f2prefix clientmod)
(haskell-refac-renameAllIdentsIn f3 f3prefix clientmod)

; 9) clean useless import ---------------------------------------------------------------------
(haskell-refac-cleanImportsMod clientmod)

